javax.faces.view.facelets

## Class MetaRule

- java.lang.Object
- - javax.faces.view.facelets.MetaRule

-     public abstract class MetaRule
      extends Object

  The root class of the abstraction that dictates how attributes on a markup element in a Facelets VDL page are wired to the JSF API object instance associated with that element. The single method on this interface, `applyRule(java.lang.String, javax.faces.view.facelets.TagAttribute, javax.faces.view.facelets.MetadataTarget)`, returns an encapsulation of the behavior that actually does the work of handling the attribute and its value. There are implementations of specific concrete subclasses of this class for all the basic kinds of elements that appear in Facelets VDL pages: components, non-components, and attached objects.

  For example, consider this markup:

  `

      <h:inputText value="#{user.userid}"
                      valueChangeListener="#{user.newUserId}" />

  ` Two `MetaRule` instances are involved in this example.

  1. The first has an `applyRule()` method that returns a `Metadata` instance that, when its `applyMetada()` method is called, dictates how the "value" attribute is processed: calling `UIComponent.setValueExpression(java.lang.String, javax.el.ValueExpression)` on the `UIComponent` instance associated with the `<h:inputText>` element.

  2. The second has an `applyRule()` method that returns a `Metadata` instance that, when its `applyMetadata()` method is called, dictates how the "valueChangeListener" attribute is processed: calling `EditableValueHolder.addValueChangeListener(javax.faces.event.ValueChangeListener)`.

  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MetaRule()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract Metadata` | `applyRule(String name, TagAttribute attribute, MetadataTarget meta)` Return an abstraction that takes appropriate action given the kind of rule represented by the argument `name`, in the context of this particular concrete subclass of `MetaRule`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MetaRule

          public MetaRule()

  - ### Method Detail

    - #### applyRule

          public abstract Metadata applyRule(String name,
                           TagAttribute attribute,
                           MetadataTarget meta)

      Return an abstraction that takes appropriate action given the kind of rule represented by the argument `name`, in the context of this particular concrete subclass of `MetaRule`. The abstraction must encapsulate the value from the argument `attribute`.

      Parameters:
        `name` - the name for this rule. This will generally be the name of a tag attribute in the VDL.
        `attribute` - the name/value pair for this attribute on this particular instance of an element in the page.
        `meta` - the `MetadataTarged` that can be used to discern what kind of action to encapsulate within the abstraction to be returned.
      Since:
        2.0

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.